// Example 4
// What is standsurv doing?s
// Paul Lambert 2024-08-08

clear all
cd $stpm3course\data
set scheme fpsaus_c

use breast_NW

stset survtime, failure(dead==1) exit(time 5)
 
 
// Fit a model with age and deprivation group
stpm3 i.dep##@ns(agediag,df(3)), scale(lncumhazard) df(4) ///
                                 tvc(i.dep##@ns(agediag,df(3))) dftvc(3)
estimates store stpm3                                 

// let's predict survival at 5 years for all subject
gen t5 = 5
predict S5, surv timevar(t5) merge

// histogram
hist S5                                 

// mean survival
mean S5

// Kaplan-Meier at 5 years
sts list, risktable(5)

// We can get the same estimate in standsurv
estimates restore stpm3
range tt 0 5 101
standsurv, surv at1(.) frame(ss, replace) atvar(S5) timevar(tt) ci

// note we get a confidence interval
frame ss: list tt S5* if tt==5, noobs

// manipulation of exposures
gen olddep = dep

// make everyone be in deprivation group 1
replace dep = 1
predict S5d1, surv timevar(t5) merge

// make everyone be in deprivation group 1
replace dep = 5
predict S5d5, surv timevar(t5) merge

// change back (please do not code like this for real)
replace dep = olddep

summ S5d1 S5d5
// Why can't we compate these to Kaplan-Meier estimates?

// repeat in standsurv
standsurv, surv at1(dep 1) at2(dep 5) frame(ss, merge) atvar(S5d1 S5d5) timevar(tt)

// same estimates as above
frame ss: list tt S5d1 S5d5 if tt==5, noobs




